;==============================================================================
    include \masm32\include\masm32rt.inc
;==============================================================================
    .data
      hInst   HMODULE 0
      clientW dd      0
      clientH dd      0
    .code
;==============================================================================

DlgProc proc hwndDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL hdcClient:HDC
    LOCAL ps:PAINTSTRUCT
    LOCAL rc:RECT

    SWITCH uMsg

      CASE WM_INITDIALOG

        ;-------------------------------------------------------
        ; Get and save the width and height of the client area.
        ;-------------------------------------------------------

        invoke GetClientRect, hwndDlg, addr rc
        mov eax, rc.right
        inc eax
        mov clientW, eax
        mov eax, rc.bottom
        inc eax
        mov clientH, eax

      CASE WM_CTLCOLORDLG

        ;------------------------------------------
        ; Set the client area background to black.
        ;------------------------------------------

        invoke GetStockObject, BLACK_BRUSH
        ret

      CASE WM_PAINT

        invoke BeginPaint, hwndDlg, ADDR ps

        ;----------------------------------------------
        ; Select the DC pen into the paint DC and save
        ; the previously selected object on the stack.
        ;----------------------------------------------

        invoke GetStockObject, DC_PEN
        invoke SelectObject, ps.hdc, eax
        push eax

        ;-----------------------------------------
        ; Set the DC pen color to gray and draw a
        ; horizontal line to serve as a x axis and
        ; a vertical line to serve as a y axis.
        ;-----------------------------------------

        invoke SetDCPenColor, ps.hdc, 808080h
        invoke MoveToEx, ps.hdc, 0, 255, NULL
        invoke LineTo, ps.hdc, clientW, 255
        invoke MoveToEx, ps.hdc, 20, 0, NULL
        invoke LineTo, ps.hdc, 20, clientH

        ;---------------------------------
        ; Plot a sin wave using SetPixel.
        ;---------------------------------

        mov ecx, 0
        .WHILE ecx < clientW
            push ecx
            fild DWORD PTR [esp]
            pop ecx
            fld8 120.00
            fdiv
            fsin
            fld8 120.00
            fmul
            fld8 255.0
            fadd
            push eax
            fistp DWORD PTR [esp]
            pop eax
            push ecx
            add ecx, 20
            invoke SetPixel, ps.hdc, ecx, eax, 0ff00h
            pop ecx
            inc ecx
        .ENDW

        ;----------------------------------------------------
        ; Select the original object back into the paint DC.
        ;----------------------------------------------------

        pop eax
        invoke SelectObject, ps.hdc, eax

        invoke EndPaint, hwndDlg, ADDR ps

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            invoke EndDialog, hwndDlg, 0

        ENDSW

      CASE WM_CLOSE

        invoke EndDialog, hwndDlg, 0

    ENDSW

    xor eax, eax
    ret

DlgProc endp

;==============================================================================
start:
;==============================================================================

    invoke GetModuleHandle, NULL
    mov hInst, eax

    Dialog "Test", \
           "MS Sans Serif",8, \
           WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
           0,0,0,400,300,1024

    CallModalDialog hInst,0,DlgProc,NULL

    exit
;==============================================================================
end start